
* EXAMPLE 9 - USE A CNTLIN DATA SET FOR RECORD SELECTION (ADD AN OTHER CONDITION);

data selectssns / view=selectssns;
retain fmtname 'ssnok' label 'ok';
infile 'k:\epi697\data\getssns.dat' end=last;
if last then do;
   hlo = 'o';
   label = 'no';  
   output;
end;
input start comma11.;
output;
run;

proc format cntlin=selectssns;
run;

data goodssns;  
infile 'k:\epi697\data\lotassns.dat';
input ssn comma11. record $6.;
if put(ssn,ssnok.) eq 'ok';  
run;

*****************************************************************;

proc datasets lib=work memtype=view nolist;
delete selectssns;
quit;

*****************************************************************;

* use an INDEX;

data selectssns (index=(ssn));
infile 'k:\epi697\data\getssns.dat';
input ssn comma11.;
run;

data goodssns;  
infile 'k:\epi697\data\lotassns.dat';
input ssn comma11. record $6.;
set selectssns key=ssn / unique; 
if _error_ then _error_ = 0;
else output;
run;

*****************************************************************;

proc datasets lib=work nolist;
delete selectssns;
quit;

*****************************************************************;

* use a HASH data set object;

data selectssns;
infile 'k:\epi697\data\getssns.dat';
input ssn comma11.;
run;

data goodssns;  
declare hash s (dataset:'selectssns');
s.definekey ('ssn');
s.definedone();

infile 'k:\epi697\data\lotassns.dat' end=done;
do until (done);
   input ssn comma11. record $6.;
   if not s.find() then output;
end;
stop;
run;

*****************************************************************;

proc datasets lib=work nolist;
delete selectssns;
quit;

